
-- Fall-Winter Demo 2012
-- turtlesort.com
-- Kevin Sacro

local script = {}

function script.notify(event, ...)

	if event == 'mapload' then
		-- Allows us to warp here from any map
		-- There is also only one starting location
		game.player.moveTo(47,47,'down')
		game.player.drawCollisionBox = false
		-- game.maps.currentMap.layers.Player.visible = false -- This does nothing since we're on another map
	
	elseif event == 'mapfadeincomplete' then -- player movement must be disabled during text
	
		-- Start the first demo on the map
		script.demo()

	end
end


function script.demo()

	--[
	local ec = require 'lib.exp.eventchain'
	
	ec.newChain(
		function(callback)

			game.text.displayText({
				--   |----------------------------|
					"{@3}",
					"This demo uses a very basic",
					"camera system. It can either",
					"center on the player or",
					
					"move to a set of coordinates.",
					"Chaining targets allows the",
					"camera to pan around the map."
				},
				function()
					-- Default post-action is to let player move.
					-- Here we are saying to disable it again if
					-- the camera is still moving around on map.
					if game.camera.target ~= game.player then
						game.player.canMove = false
					end
				end
			)
			game.camera.speed = 400
			game.camera.targetTile(12,45,callback)
		end,
		
		function(callback)
			game.camera.targetTile(12,28,callback)
		end,
		
		function(callback)
			game.camera.targetTile(32,28,callback)
		end,
		
		function(callback)
			game.camera.speed = 700
			game.camera.setTarget({
			    x = game.player.x + game.player.width/2,
		        y = game.player.y - game.player.height/2},
				callback
			)
		end,
		
		function()
			game.camera.setTarget(game.player)
			if not game.text.enabled then
				game.player.canMove = true
			end
		end
		
	):run()
	--]]
	
end

return script