
-- Fall-Winter Demo 2012
-- turtlesort.com
-- Kevin Sacro

-- The main menu of the demo. We are using josefnpat's Lovemenu
-- with minor enhancements for better integration with the demo.

local scene = {}
local menu = require "libexternal.lovemenu.menu2"

function scene.init()

	-- This font looks nicer in the menu
	game.font.setDefaultFont('fonts/LeagueGothic/LeagueGothic-Regular.otf')

	-- Initial setup, the first five below are mandatory before
	-- calling toggle.
	menu.font_title = game.font.get(70)
	menu.font_desc  = game.font.get(30)
	menu.font_menu  = game.font.get(48)
	menu.icon       = love.graphics.newImage("art/menu_cursor.png")
	menu.bg         = love.graphics.newImage("art/bg.png")
	
	menu.bg_alpha = 250
	menu.title_y  = love.graphics.getHeight()/2 + 48
	
	-- The demo does not use any mouse control. If we
	-- allow it to be used in the menu the player may
	-- get confused once in-game
	menu.enablemouse = false 
	
	menu:toggle()
	menu_view = {}
		menu_view[1] = {
		title="Fall-Winter Demo 2012",
		-- desc="A small demo showcasing some basic features you would find in a tile-based rpg game.",
		desc="",
		{t="Begin Demo", cb="begin_demo"},
		{t="Credits",    cb="show_credits"},
		{t="Exit",       cb="exit"}
	}
	
	menu_view[3] = {
		title="",
		desc="",
		{t="Confirm",cb="confirmed_exit"},
		{t="Return",cb="show_mainmenu"}
	}
	
	menu_view[4] = {
		title="",
		desc=
			"\n\n\n" ..
			"FALL-WINTER DEMO 2012" .. "\n" ..
			"and the TURTLESORT LIB" .. "\n" ..
			"\n" ..
			
			"Kevin Sacro (kesac)"     .. "\n" ..
			"turtlesort.com"          .. "\n" ..
			"\n"
			
		,{t="Continue",cb="continue_credits"}
	}
	
	menu_view[5] = {
		title="",
		desc=
			"\n\nADVANCED TILED LOADER"  .. "\n" ..
			"Casey Baxter (Kadoba)"                    .. "\n" ..
			"github.com/Kadoba/Advanced-Tiled-Loader"  .. "\n" ..
			"\n" ..
			
			"LOVEMENU"   .. "\n" ..
			"Josef Patoprsty (josefnpat)"       .. "\n" ..
			"github.com/josefnpat/lovemenu/"    .. "\n" ..
			"\n"

		,{t="Continue",cb="continue_credits2"}
	}
	
	menu_view[6] = {
		title="",
		desc=
			"TILESETS"              .. "\n" ..
			"MrBeast and Stephen Challener (Redshrike)"   .. "\n" ..
			"opengameart.com" .. "\n" ..
			"\n" ..
			"CHAR SPRITES"     .. "\n" ..
			"Antifarea"     .. "\n" ..
			"opengameart.com" .. "\n" ..
			"\n" ..
			"MENU BACKGROUND\n" ..
			"Kevin Sacro (kesac)\n" ..
			"turtlesort.com\n"  ..
			"\n" ..
			"See attribution.txt for more details"

		,{t="Return",cb="show_mainmenu"}
	}
	
	menu:load(menu_view)
	videomodes = love.graphics.getModes()
	currentmode = 1  

end

function menu:callback(cb)
	if cb == "begin_demo" then
		game.transitionTo("preprimary")

	elseif cb == "show_credits" then
		menu:setstate(4)

	elseif cb == "continue_credits" then
		menu:setstate(5)
		
	elseif cb == "continue_credits2" then
		menu:setstate(6)

	elseif cb == "exit" then
		menu:setstate(3)

	elseif cb == "confirmed_exit" then
		love.event.quit()

	elseif cb == "show_mainmenu" then
		menu:setstate(1)
	end
end

function scene.update(dt)
	menu:update(dt)
end

function scene.draw()
	menu:draw()
end

function scene.keypressed(key,unicode)
	menu:keypressed(key)
end

-- We are not handling mouse events on purpose!

return scene